%global version_major 1
%global version_minor 2
%global version_micro 23
%global meadalpha %{nil}
%global meadrel %{nil}
%global commitid d140fe8756db61fd8fef021ed2e01942cdbe59d2
%global serial 23

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

#no jars in this native build, so skip signing
%define _jarsign_opts --nocopy

# scldir points to the root dir of the jbcs collection
%define scldir /opt/rh/jbcs-httpd24/root

%define _with_zips 1
# If you want to build the zips,
# give rpmbuild option '--with zips'

%define with_zips %{?_with_zips:1}%{!?_with_zips:0}
%define without_zips %{!?_with_zips:1}%{?_with_zips:0}

%define packdname %{name}-%{version}-src

Name:           tomcat-native
Version:        %{version_major}.%{version_minor}.%{version_micro}
Release:        %{serial}.redhat_%{serial}%{?dist}
Summary:        Tomcat native library

Group:          System Environment/Libraries
License:        ASL 2.0
URL:            http://tomcat.apache.org/tomcat-6.0-doc/apr.html

Source0:        %{name}-%{commitid}.tar.gz

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
%if "%{?rhel}" == "7"
# 64 bit only natives on RHEL 7
ExcludeArch:   i686 i386
%endif

%if "%{?rhel}" == "7"
BuildRequires:  java-devel
%else
BuildRequires:  java7-devel
%endif

BuildRequires:  jbcs-httpd24-apr, jbcs-httpd24-apr-devel
BuildRequires:  jpackage-utils
BuildRequires:  jbcs-httpd24-openssl, jbcs-httpd24-openssl-devel, jbcs-httpd24-openssl-libs
BuildRequires:  zip
BuildRequires:  autoconf

Requires:       jbcs-httpd24-apr, jbcs-httpd24-openssl
Requires(pre):  shadow-utils

%global __requires_exclude libapr.*
%{?filter_setup:
%filter_from_requires /libapr.*/d
%filter_setup
}

# Upstream compatibility:
Provides:       tcnative = %{version}-%{release}

%description
Tomcat can use the Apache Portable Runtime to provide superior
scalability, performance, and better integration with native server
technologies.  The Apache Portable Runtime is a highly portable library
that is at the heart of Apache HTTP Server 2.x.  APR has many uses,
including access to advanced IO functionality (such as sendfile, epoll
and OpenSSL), OS level functionality (random number generation, system
status, etc), and native process handling (shared memory, NT pipes and
Unix sockets).  This package contains the Tomcat native library which
provides support for using APR in Tomcat.

%if %{with_zips}
%package src-zip
Summary:     Container for the sources of the Tomcat native library.
Group:       Development

%description src-zip
Container for the sources of the Tomcat native library
%endif

%prep
%setup -q -n %{name}-%{commitid}

%if %{with_zips}
zip -q -r ../%{packdname}.zip *
%endif

%build
cd native

# Setting LDFLAGS equal to the global_ldflags value so that we
# append new values instead of clobber them.
%{?__global_ldflags:LDFLAGS="%__global_ldflags"}
test -d "%{?scldir}/usr/lib64" && \
LDFLAGS="-L%{?scldir}/usr/lib64 $LDFLAGS" || \
LDFLAGS="-L%{?scldir}/usr/lib $LDFLAGS"
LDFLAGS="$LDFLAGS -Wl,-z,relro,-z,now"
# Export require for rhel-6; rhel-6 handles this in the configure macro
export LDFLAGS
./buildconf --with-apr=%{?scldir}%{_libdir}/apr-1
%configure \
    --with-apr=%{?scldir}%{_bindir}/apr-1-config \
    --with-ssl=%{?scldir}/usr \
    --with-java-home=%{java_home} \
    --with-java-platform=2
make %{?_smp_mflags} CFLAGS="-fno-strict-aliasing -DTCN_RELEASE_VERSION=\"-%{serial}\""

%install
rm -rf $RPM_BUILD_ROOT
make -C native install DESTDIR=$RPM_BUILD_ROOT

# Perhaps a devel package sometime?  Not for now; no headers are installed.
rm -f $RPM_BUILD_ROOT%{_libdir}/libtcnative*.*a
rm -rf $RPM_BUILD_ROOT%{_libdir}/pkgconfig
rm -rf $RPM_BUILD_ROOT%{_includedir}

%ifarch i386 i686
archdir=linux-i686
%endif
%ifarch ppc64
archdir=linux-ppc64
%endif
%ifarch x86_64
archdir=linux-x86_64
%endif

%if %{with_zips}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_javadir}/jbossas-fordev
%{__install} ../%{packdname}.zip ${RPM_BUILD_ROOT}%{_javadir}/jbossas-fordev/
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root,-)
%doc LICENSE NOTICE
# Note: unversioned *.so needed here due to how Tomcat loads the lib :(
%{_libdir}/libtcnative*.so*

%if %{with_zips}
%files src-zip
%defattr(0644,root,root,0755)
%dir %{_javadir}/jbossas-fordev
%{_javadir}/jbossas-fordev/%{packdname}.zip
%endif

%changelog
* Wed Jan 20 2021 Sokratis Zappis <szappis@redhat.com> - 1.2.23-23.redhat_23
- Build for JWS 3.1.11.CR1

* Mon Feb 03 2020 Coty Sutherland <csutherl@redhat.com> - 1.2.23-21.redhat_21
- Rebase to tomcat-native 1.2.23

* Fri Nov 16 2018 Coty Sutherland <csutherl@redhat.com> - 1.2.17-18.redhat_18
- Resolves: JWS-1140 tomcat-native memory leak when using Mutual authentication + OCSP

* Mon Jul 30 2018 Jean-Frederic Clere <jclere@redhat.com> - 1.2.17-15.redhat_15
- Use apr (and openssl via RCM-38172) from jbcs httpd-2.4.29

* Tue Jul 03 2018 Coty Sutherland <csutherl@redhat.com> - 1.2.17-14.redhat_14
- Rebase to tomcat-native 1.2.17

* Wed Mar 28 2018 Coty Sutherland <csutherl@redhat.com> - 1.2.8-13.redhat_13
- Related: JWS-934 Update requires to correct file location

* Tue Mar 27 2018 Coty Sutherland <csutherl@redhat.com> - 1.2.8-12.redhat_12
- Resolves: JWS-934 Use new standalone APR package from JBCS

* Mon Dec 18 2017 Coty Sutherland <csutherl@redhat.com> - 1.2.8-9.redhat_9
- Resolves: JWS-865 Correctly calculate field lengths when parsing the OCSP extension so that longer values are read correctly

* Mon Feb 27 2017 Coty Sutherland <csutherl@redhat.com> - 1.2.8-8.redhat_8
- Resolves: JWS-657 tomcat-native installs RHEL apr in addition to jbcs-httpd24-httpd-libs

* Thu Feb 02 2017 Coty Sutherland <csutherl@redhat.com> - 1.2.8-7.redhat_7
- Resolves: JWS-616 tomcat-native uses the wrong APR library

* Fri Sep 09 2016 Coty Sutherland <csutherl@redhat.com> - 1.2.8-6.redhat_6
- Adjusting BuildRequires after JBCS-150 was fixed

* Fri Jul 08 2016 Coty Sutherland <csutherl@redhat.com> - 1.2.8-1.redhat_1
- Building 1.2.8 as JWS 3.1 candidate

* Wed Jun 01 2016 Coty Sutherland <csutherl@redhat.com> - 1.2.6-2.redhat_1
- Update LDFLAGS setting to include %__global_ldflags value instead of ignoring the previous value
- Add export of LDFLAGS to fix rhel-6 builds

* Thu Apr 21 2016 Coty Sutherland <csutherl@redhat.com> - 1.2.6-1.redhat_1
- Building 1.2.6 as JWS 3.1 candidate
